#region usings
using System;
using System.ComponentModel.Composition;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;

using VVVV.Core.Logging;
#endregion usings

namespace VVVV.Nodes
{
	#region PluginInfo
	[PluginInfo(Name = "Umbruch", Category = "Value", Help = "Basic template with one value in/out", Tags = "")]
	#endregion PluginInfo
	public class ValueUmbruchNode : IPluginEvaluate
	{
		#region fields & pins
		[Input("BinSize", DefaultValue = 1.0)]
		public ISpread<double> FBinSize;
				
		[Input("Ëlement Width", DefaultValue = 1.0)]
		public ISpread<double> FElWidth;
		
		[Input("TotalWidth", DefaultValue = 1.0)]
		public ISpread<double> FTotWidth;

		[Output("Output")]
		public ISpread<double> FOutput;
		
		[Output("YOutput")]
		public ISpread<double> FYOutput;
		
		double currentpos = 0;
		double currentypos = 0;

		[Import()]
		public ILogger FLogger;
		#endregion fields & pins

		//called when data for any output pin is requested
		public void Evaluate(int SpreadMax)
		{
			FOutput.SliceCount = SpreadMax;
			FYOutput.SliceCount = SpreadMax;

			for (int i = 0; i < SpreadMax; i++)
			{
				
				if (currentpos > FTotWidth [i]){
					currentpos = 0;
					currentypos = currentypos+1;
					}
				
				FOutput[i] = currentpos;
				FYOutput[i] = currentypos;
				
				currentpos = currentpos + FElWidth [i];
			}
			currentpos = 0;
			currentypos = 0;
			//FLogger.Log(LogType.Debug, "hi tty!");
		}
	}
}
