#region usings
using System;
using System.ComponentModel.Composition;
using System.Collections.Generic;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Core;

using VVVV.Core.Logging;
#endregion usings

namespace VVVV.Nodes
{
	[PluginInfo(Name = "FrameDifference", Category = "Animation", Help = "ID", Tags = "")]
	public class ValueSandboxNode : IPluginEvaluate
	{
		#region fields & pins
		[Input("Input")]
		ISpread<double> FInput;
		
		[Input("Default")]
		ISpread<double> FDefault;
		
		[Input("Id")]
		ISpread<int> FId;
		
		[Output("Output")]
		ISpread<double> FOutput;
		
		[Input("Set")]
		ISpread<bool> FSet;
		
		[Input("Reset")]
		ISpread<bool> FReset;
		
		Dictionary<int, double> dictdiff = new Dictionary<int, double>();
		Dictionary<int, double> dictintegral = new Dictionary<int, double>();
		Dictionary<int, double> dictvel = new Dictionary<int, double>();
		
		#endregion fields & pins
		
		//called when data for any output pin is requested
		public void Evaluate(int SpreadMax)
		{
		FOutput.SliceCount=FId.SliceCount;
			
			#region nicht mehr vorhandene ids aus dictionary löschen
			List<int> tbd = new List<int>();
			foreach (int key in dictdiff.Keys)
				if (FId.IndexOf(key) == -1)
					tbd.Add(key);
			
			foreach (int key in tbd){ 
				dictdiff.Remove(key);			//remove ids from dictionary which are not on the id input pin anymore
			    dictintegral.Remove(key);		//remove ids from dictionary which are not on the id input pin anymore
				dictvel.Remove(key);		//remove ids from dictionary which are not on the id input pin anymore
			}
			#endregion nicht mehr vorhandene ids aus dictionary löschen
			
			for (int i=0; i<FId.SliceCount; i++)
			{
				if (dictdiff.ContainsKey(FId[i])) //if the id is allready in the dictionaty
				{
					 if (FSet[i]) {
					   	dictintegral[FId[i]]= dictintegral[FId[i]]+(FInput[i]-dictdiff[FId[i]]); //last result + framedifference
					 	dictvel[FId[i]]=FInput[i]-dictdiff[FId[i]];
					   }
					else {
						dictintegral[FId[i]]=dictintegral[FId[i]]+dictvel[FId[i]];
						dictvel[FId[i]]=0.99*dictvel[FId[i]];
					}
					 if (FReset[i]){
					   	dictintegral[FId[i]]=FDefault[i]; //set to default
					 	dictvel[FId[i]]=0;
					 	dictdiff[FId[i]]=0;
					   }
					dictdiff[FId[i]]=FInput[i]; //dictdiff set to lastframe
				}
				else // if id is not allready in the dictionary
				{
					dictdiff.Add(FId[i],FInput[i]); // slice in dictionarry adden
					dictintegral.Add(FId[i],FDefault[i]); // slice in dictionarry adden
					dictvel.Add(FId[i],FDefault[i]); // slice in dictionarry adden
				}
				FOutput[i]=dictintegral[FId[i]]; //Output setzen
			}
		}
	}
}
