#region usings
using System;
using System.ComponentModel.Composition;
using System.Collections.Generic;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Core;

using VVVV.Core.Logging;
#endregion usings

namespace VVVV.Nodes
{
	[PluginInfo(Name = "DragNSlide", Category = "Animation", Help = "ID", Tags = "")]
	public class AnimationDragNSlideNode : IPluginEvaluate
	{
		#region fields & pins
		[Input("Input")]
		ISpread<double> FInput;

		[Input("Default")]
		ISpread<double> FDefault;

		[Input("Id")]
		ISpread<string> FId;

		[Output("Output")]
		ISpread<double> FOutput;

		[Input("Set")]
		ISpread<bool> FSet;

		[Input("Reset")]
		ISpread<bool> FReset;
		
		[Input("Friction")]
		ISpread<double> FFriction;
		
		[Input("Min")]
		ISpread<double> FMin;
		
		[Input("Max")]
		ISpread<double> FMax;

		Dictionary<string, double> dictdiff = new Dictionary<string, double>();
		Dictionary<string, double> dictintegral = new Dictionary<string, double>();
		Dictionary<string, double> dictvel = new Dictionary<string, double>();
		
		
		#endregion fields & pins

		//called when data for any output pin is requested
		public void Evaluate(int SpreadMax)
		{
			FOutput.SliceCount = FId.SliceCount;

			#region nicht mehr vorhandene ids aus dictionary löschen
			List<string> tbd = new List<string>();
			foreach (string key in dictdiff.Keys)
				if (FId.IndexOf(key) == -1)
					tbd.Add(key);

			foreach (string key in tbd) {
				dictdiff.Remove(key);
				//remove ids from dictionary which are not on the id input pin anymore
				dictintegral.Remove(key);
				//remove ids from dictionary which are not on the id input pin anymore
				dictvel.Remove(key);
				
			}
			#endregion nicht mehr vorhandene ids aus dictionary löschen

			for (int i = 0; i < FId.SliceCount; i++) {
				//if the id is allready in the dictionaty
				if (dictdiff.ContainsKey(FId[i])) {
					if (FSet[i]) {
						dictintegral[FId[i]] = dictintegral[FId[i]] + (FInput[i] - dictdiff[FId[i]]); //last result + framedifference
						dictvel[FId[i]] = FInput[i] - dictdiff[FId[i]];
					} else {
						dictintegral[FId[i]] = dictintegral[FId[i]] + dictvel[FId[i]];
						dictvel[FId[i]] = (1-FFriction[i]) * dictvel[FId[i]];
					}
					if (FReset[i]) {
						dictintegral[FId[i]] = FDefault[i];
						//set to default
						dictvel[FId[i]] = 0;
						dictdiff[FId[i]] = 0;
					}
					dictdiff[FId[i]] = FInput[i]; //dictdiff set to lastframe
													// if id is not allready in the dictionary
				} 
				
				else {										// slices in dictionarry adden
					dictdiff.Add(FId[i], FInput[i]);		
					dictintegral.Add(FId[i], FDefault[i]);
					dictvel.Add(FId[i],FDefault[i]);

				}
				dictintegral[FId[i]] = Math.Min(FMax[i], dictintegral[FId[i]]);
				dictintegral[FId[i]] = Math.Max(FMin[i], dictintegral[FId[i]]);
				FOutput[i] = dictintegral[FId[i]];
				//Output setzen
			}
		}
	}
}
