#region usings
using System;
using System.ComponentModel.Composition;
using System.Collections.Generic;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;

using VVVV.Core.Logging;

using VVVV.PluginInterfaces.V2.Graph;
#endregion usings

namespace VVVV.Nodes
{
	#region PluginInfo
	[PluginInfo(Name = "PatchStatistics", Category = "VVVV", Help = "Basic template with one value in/out", Tags = "")]
	#endregion PluginInfo
	public class VVVVPatchStatisticsNode : IPluginEvaluate
	{
		#region fields & pins
		[InputAttribute("Do Scan",IsBang=true)]
		ISpread<bool> FDoScan;
		
		[OutputAttribute("Name")]
		ISpread<string> FOutName;
		
		[OutputAttribute("Count")]
		ISpread<int> FCount;
		
		[OutputAttribute("Path")]
		ISpread<string> FOutPath;
		
		[ImportAttribute()]
		IHDEHost FHde;
		
		private Dictionary<string,int> stats = new Dictionary<string,int>();
		
		

		#endregion fields & pins

		//called when data for any output pin is requested
		public void Evaluate(int SpreadMax)
		{
			if (FDoScan[0])
			{
				stats.Clear();
				this.ProcessNode(this.FHde.RootNode);
				this.FOutName.SliceCount = stats.Count;
				this.FCount.SliceCount = stats.Count;
				
				int cnt = 0;
				foreach (string name in stats.Keys)
				{
					this.FOutName[cnt] = name;
					this.FCount[cnt] = stats[name];
					cnt ++;
				}
			}
		}
		
		public void ProcessNode(INode2 node)
		{
			if (node.HasPatch)
			{
				foreach (INode2 child in node)
				{
					this.ProcessNode(child);
				}
			}
			
			string type = node.NodeInfo.Type.ToString();
		//	if (type == "Patch")
		//	{
			string sysname = node.NodeInfo.Filename;
		//	string sysname = node.NodeInfo.Type.ToString();
				
		//	}
			
			if (stats.ContainsKey(sysname))
			{
				//Get current count
				int count = stats[sysname];
				count ++;
				stats[sysname] = count;
			}
			else
			{
				stats.Add(sysname,1);
			}
		}
	}
}
